local mod = RW:Boss("General Vezax", "Ulduar", "Ulduar")
local L

---------------------------
-- Variables
local wSurgeofDarknessCast
local wShadowCrash, iShadowCrash
local wMarkoftheFaceless, iMarkoftheFaceless
local tSearingFlameCast
local tSurgeofDarknessCast, tSurgeofDarknessDur, mSurgeofDarkness
local tHardmode
local tBerserk

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "General Vezax"
		
		L.YellPull = "Your destruction will herald a new age of suffering!"
		L.YellHard = "Behold, now! Terror, absolute!"
		L.YellDeath	= "Oh, what horrors await...."
		L.Surge_msg = "Surge of Darkness %d"
		L.Surge_opt	= "Surge of Darkness counter message"
		L.Hardmode = "Hard mode"
		L.Hardmode_msg = "Saronite Animus spawning"
		L.Hardmode_opt = "Hardmode engaged message"
		end

	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(L.YellPull, 33271)
	self:SetWin(L.YellDeath, 33271)
	
	tSearingFlameCast	= self:CastTimer(62661)
	tSurgeofDarknessCast	= self:CastTimer(62662)
	tSurgeofDarknessDur	= self:DurTimer(10, 62662)
	tSurgeofDarknessCD	= self:CDTimer(50, 62662)
	tHardmode			= self:AchievementTimer(200, 3181, L.Hardmode)
	
	wSurgeofDarknessCast = self:RunawayWarning(62662, nil, nil, false)
	wShadowCrash 		= self:RunawayWarning(62660)
	wMarkoftheFaceless	= self:RunawayWarning(63276)
	
	mSurgeofDarkness	= self:CustomMessage(L.Surge_msg, L.Surge_opt, 62662)
	mHardmode			= self:CustomMessage(L.Hardmode_msg, L.Hardmode_opt, 63364, L.Hardmode_opt)
	
	iShadowCrash 		= self:Icon("SKULL", 63277, true, 10)
	iMarkoftheFaceless	= self:Icon("CROSS", 63276, true, 10)
	
	tBerserk 			= self:BerserkTimer(600)
end

---------------------------
-- Locals
local SurgeofDarknessCounter = 0

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("ShadowCrash", 62660)
	self:Track("MarkoftheFaceless", 63276)
	self:Track("SearingFlame", 62661)
	self:Track("SurgeofDarkness", 62662)
	self:YellTrack("Hardmode", L.YellHard)
	
	tHardmode:Start()
	tBerserk:Start()
	SurgeofDarknessCounter = 0
end

function mod:CrashTarget()
	local target = self:GetMobTarget(33271)
	if not target then return end
	iShadowCrash:Show(target)
	if UnitName(target) == self.pName then
		wShadowCrash:Show()
		SendChatMessage("Shadow Crash on me!", "SAY")
	end
end

function mod:ShadowCrash(event, args)
	if event == "SPELL_CAST_SUCCESS" then
	 	self:Schedule("CrashSchedule", 0.2, "CrashTarget")
	end
end

function mod:MarkoftheFaceless(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		if args:IsPlayer() then
			wMarkoftheFaceless:Show()
		end
		iMarkoftheFaceless:Show(args.dName)
	end
end

function mod:SearingFlame(event, args)
	if event == "SPELL_CAST_START" then
		tSearingFlameCast:Start()
	end
	if event == "SPELL_INTERRUPT" then
		tSearingFlameCast:Cancel()
	end
end	

function mod:SurgeofDarkness(event, args)
	if event == "SPELL_CAST_START" then
		wSurgeofDarknessCast:Show()
		SurgeofDarknessCounter = SurgeofDarknessCounter + 1
		tSurgeofDarknessCast:Start()
		mSurgeofDarkness:Show(SurgeofDarknessCounter)
	end
	if event == "SPELL_AURA_APPLIED" then
		tSurgeofDarknessDur:Start()
	end
	if event == "SPELL_AURA_REMOVED" then
		tSurgeofDarknessCD:Start()
	end
end

function mod:Hardmode(event, msg, name)
	mHardmode:Show()
end